// MouseOffroad, by AK (2:5019/10.99, GroupStudio@mail.ru)

program MouseOffRoad;

uses
  SysUtils, Windows, IniFiles, Messages;

var pX1, pY1: Integer;
    timerID : Integer;

    DeskDC : THandle;
    DelEv : Integer;

    OEMConv, ShowOnDesk : boolean;
    Distance, SaveConf : Integer;
    SaveResult,
    ResultFormatA,
    ResultFormatB,

    ResultFormatC,
    ResultFormatD : String;
    SpeedCoofTime, SpeedCoofDist, DistCoof, TimeCoof : Single;
    TotalTime : Integer;

    LabelX, LabelY : Integer;

//    ConsoleProcessMessages  
//   true,     .
var TerminateApp : Boolean;


function ConsoleProcessMessage(var Msg: TMsg): Boolean;
begin
  Result := False;
  if PeekMessage(Msg, 0, 0, 0, PM_REMOVE) then
  begin
    Result := True;
    if Msg.Message = WM_QUIT then
     TerminateApp := True;
    DispatchMessage(Msg);
  end;
end;

procedure ConsoleProcessMessages;
var
  Msg: TMsg;
begin
  while ConsoleProcessMessage(Msg) do {loop};
end;

function StrANSItoOEM(St:String):String;
begin
  Result := '';
  if st = '' then exit;
  SetLength(Result, Length(St));
  CharToOEM(PChar(St), PChar(Result));
end;


function GetFormattedResult:String;
var Speed : single;
begin
   try
    Speed := ((Distance/3200*distCoof*SpeedCoofDist) / (TotalTime*timeCoof*SpeedCoofTime));
    if ResultFormatA <> '' then
     Result := Format(ResultFormatA, [Distance/3200*distCoof]);
    if ResultFormatB <> '' then
     Result := Format(ResultFormatB, [Distance/3200*distCoof, Speed ]);
    if ResultFormatC <> '' then
     Result := Format(ResultFormatC, [Distance/3200*distCoof, Speed, TotalTime*timeCoof]);
    if ResultFormatD <> '' then
     Result := Format(ResultFormatD, [Distance/3200*distCoof, TotalTime*timeCoof]);

   except
    KillTimer(0, timerID);
    MessageBox(0, '    ResultFormat !', ' ', 0);
    halt;
   end
end;

function GetDirectory(St:string):String;
begin
  Result := St;
  if Length(st) > 0 then
   if not (st[Length(st)] in ['\', '/']) then
    Result := Result + '\';
end;

procedure SaveConfig;
var f :TextFile;
begin
   with TIniFile.Create(GetDirectory(ExtractFilePath(Paramstr(0)))+'MouseOffRoad.ini') do
    try
     try
       WriteInteger('DYNAMIC', 'Distance', Distance);
       WriteInteger('DYNAMIC', 'TotalTime', TotalTime);
     finally
      Free;
     end;
    except {} end;


    if SaveResult <> '' then
     begin
      AssignFile(f, SaveResult);
      Rewrite(f);
      Writeln(f, StrAnsiToOEM(GetFormattedResult));
      CloseFile(f);
     end;
end;


procedure ReadConfig;
begin
   with TIniFile.Create(GetDirectory(ExtractFilePath(Paramstr(0)))+'MouseOffRoad.ini') do
    try
     try
      Distance := ReadInteger('DYNAMIC', 'Distance', 1);
      TotalTime := ReadInteger('DYNAMIC', 'TotalTime', 1);
      ShowOnDesk := ReadBool('MAIN', 'ShowOnDesk', true);
      LabelX := ReadInteger('MAIN', 'LabelX', 10);
      LabelY := ReadInteger('MAIN', 'LabelY', 10);
      SpeedCoofTime := ReadFloat('MAIN', 'SpeedCoofTime', 1);
      SpeedCoofDist := ReadFloat('MAIN', 'SpeedCoofDist', 1);
      DistCoof := ReadFloat('MAIN', 'DistCoof', 1);
      TimeCoof := ReadFloat('MAIN', 'TimeCoof', 1);
      OEMConv := ReadBool('MAIN', 'OEMConvert', true);
      SaveConf := ReadInteger('MAIN', 'AutoSave', 600);
      SaveResult := ReadString('MAIN', 'SaveResult', '');
      ResultFormatA := ReadString('MAIN', 'ResultFormatA', '');
      ResultFormatB := ReadString('MAIN', 'ResultFormatB', '');
      ResultFormatC := ReadString('MAIN', 'ResultFormatC', '');
      ResultFormatD := ReadString('MAIN', 'ResultFormatD', '');
     finally
      if Distance = 0 then Distance := 1;
      if TotalTime = 0 then TotalTime := 1;
      Free;
     end;
    except {} end;
end;

function DistOf(px,py, p1x,p1y :Integer):Integer;
var kat1, kat2 : Integer;
begin
   kat1 := abs(px - p1x);
   kat2 := abs(py - p1y);
   Result := Round(sqrt(sqr(kat1) + sqr(kat2)));
end;

procedure TimerProc(hwnd:HWND; uMsg,idEvent:Integer; dwTime: DWord); stdcall;
const tme:Integer = 0;
var p : TPoint;
    st: String;
begin
   GetCursorPos(p);
   inc(Distance, DistOf(p.x, p.y, pX1, pY1));

   if ShowOnDesk then
    begin
     st := GetFormattedResult;
     TextOut(DeskDC, LabelX, LabelY, PChar(st), Length(st));
    end;

   inc(TotalTime);

   inc(tme);
   if tme > 10 * SaveConf then
    begin
     SaveConfig;
     tme := 0;
    end;

   pX1 := p.x; pY1 := p.y;
end;

procedure StopMouse;
begin
   KillTimer(0, timerId);
   SaveConfig;
end;

procedure StartMouse;
var p : TPoint;
begin
   DeskDC := GetDC(GetTopWindow(GetTopWindow(FindWindow('ProgMan', nil))));
   ReadConfig;

   GetCursorPos(p); pX1 := p.x; pY1 := p.y;
   timerID := SetTimer(0, 0, 1, @TimerProc);
end;

begin
    TerminateApp := False;
    Delev := CreateEvent(nil, false, false, 'DeleteMouseOffRoad');
    if FindCmdLineSwitch('U', ['-','/'], true) then
     begin
      SetEvent(DelEv);
      MessageBox(0, '  !', '', 0);
      exit;
     end;

    if FindCmdLineSwitch('?', ['-','/'], true) then
     begin
      MessageBox(0, '  :'#10+
                    '  MouseOffRoad -[?|U]'#10+
                    '    ? -   '#10+
                    '    U -  '#10#10+
                    ' v1.1 (bugfix1), by AK (2:5019/10.99, GroupStudio@mail.ru)',
                    '   ', 0);
       exit;
      end;

    CreateSemaphore(nil, 0, 1, 'MouseOffRoad');
    if GetLastError = ERROR_ALREADY_EXISTS then
     begin
      MessageBox(0, '    !'#10'   "-?"    .', '  ', 0);
      exit;
     end;

    try
     StartMouse;
     while (WaitForSingleObject(DelEv, 100) = WAIT_TIMEOUT)
       and (not TerminateApp) do
      ConsoleProcessMessages;
    finally
     StopMouse;
     ResetEvent(DelEv);
    end;
end.
